%cell-rounded-background {
    width: 32px;
    height: 32px;
    position: absolute;
    left: 50%;
    top: 50%;
    content: '';
    border-radius: 50%;
    z-index: -1;
    background-color: $primary;
    margin: -16px 0 0 -16px;
}

.datepicker {
    box-sizing: border-box !important;
    height: 40px;
    .input[type='text'],
    .input[readonly] {
        height: 40px;
        padding: 10px 16px;
        background-color: $grey100;
        border: solid 1px $grey100;
        border-radius: 3px;
        box-shadow: none !important;
        @extend %text1;

        &::placeholder {
            color: $grey600;
        }

        &:focus {
            border: solid 1px $grey200;
            outline: none !important;
            box-shadow: none !important;
        }

        &.is-danger {
            outline: none;
            border: solid 1px $red600;
            box-shadow: none !important;
        }

        &[disabled] {
            background-color: $grey200;
            border-color: $grey200;
            color: $grey900;

            &::placeholder {
                color: $grey900;
            }
        }
    }

    .dropdown.dropdown-menu-animation .dropdown-menu {
        width: 360px;

        .dropdown-content {
            max-height: 388px !important;
            padding: 0;
            max-height: unset;
            overflow: unset;
        }
    }

    .dropdown-item {
        padding: 0;

        .datepicker-header {
            padding: 0;
            margin: 0;
            border: none;
            box-shadow: 0px 32px 0px 0px $grey100;
            background-color: $grey100;
            $column-arrow-width: 32px;
            $column-list-width: 296px;

            .pagination {
                display: grid;
                grid-template-columns: $column-arrow-width $column-list-width $column-arrow-width;

                margin: 0;

                &-previous,
                &-next {
                    margin: 0;
                    color: $grey900;
                    min-width: unset;
                    height: auto;
                    flex-grow: 0 !important;

                    &:active {
                        box-shadow: unset;
                    }

                    .icon {
                        width: unset;

                        i {
                            font-size: 10px;
                            color: $grey900;
                        }
                    }
                }
                &-previous {
                    padding: 16px 0 12px 28px;
                }
                &-next {
                    padding: 16px 16px 12px;
                }

                &-list {
                    flex-grow: 1 !important;
                    margin: 16px 0 12px;
                    height: 20px;
                    .field {
                        margin: 0px;
                    }
                    .field.has-addons {
                        display: grid;
                        grid-template-columns: 1fr 1fr;
                        margin: 0;
                        :nth-child(2) {
                            text-align: left;
                        }
                    }

                    .control {
                        line-height: 20px;

                        .select {
                            height: auto;

                            &:after {
                                display: none;
                            }

                            select {
                                border: none;
                                background-color: transparent;
                                text-align: right;
                                display: flex;
                                justify-self: right;
                                padding: 0;
                                width: auto;
                                height: auto;
                                font-weight: bold;
                                @extend %text1;

                                &:first-child {
                                    text-align-last: right;
                                    direction: rtl; // for safari
                                    margin-right: 4px;
                                }
                            }
                        }
                    }
                }

                &-previous[style*='display: none;'] {
                    & ~ .pagination-list {
                        width: calc(#{$column-list-width} + #{$column-arrow-width} * 2);
                    }
                    & ~ .pagination-next {
                        padding-left: calc(#{$column-list-width} + #{$column-arrow-width} / 2);
                    }
                }
            }
        }

        .datepicker-content {
            @extend %text1;
            margin-top: -4px;
            padding-bottom: 12px;
            height: 270px;
            .datepicker-table {
                margin: 0 auto;
                border-spacing: 0 4px;

                .datepicker-header {
                    box-shadow: none;
                    background-color: unset;
                    padding: 0;

                    .datepicker-cell {
                        padding: 0 0 18px;
                        font-weight: normal;
                        width: 48px;
                    }
                }

                .datepicker-body {
                    .datepicker-cell {
                        padding: 6px 12px;
                        position: relative;
                        text-align: center;
                        z-index: 0;
                        &.dots {
                            text-align: center;
                        }
                        &.is-today {
                            border: none;
                            position: relative;
                            z-index: 0;

                            &:after {
                                width: 32px;
                                height: 32px;
                                position: absolute;
                                left: 50%;
                                top: 50%;
                                content: '';
                                border-radius: 50%;
                                border: 1px solid $purple100;
                                z-index: -1;
                                margin: -16px 0 0 -16px;
                            }
                        }

                        &.is-nearby {
                            color: $grey500;
                        }

                        &.is-first-hovered,
                        &.is-last-hovered {
                            span {
                                height: 32px;
                                width: 32px;
                                border-bottom-left-radius: 50%;
                                border-top-left-radius: 50%;
                            }
                        }

                        &.is-first-selected:not(.is-within-hovered),
                        &.is-first-hovered.is-within-hovered-range,
                        &.is-last-selected:not(.is-within-hovered),
                        &.is-last-hovered {
                            background-color: unset;
                            color: $white;

                            // light background
                            &:before {
                                width: 24px;
                                height: 32px;
                                position: absolute;
                                top: 0;
                                content: '';
                                z-index: -1;
                                background-color: $purple100;
                            }

                            // rounded background
                            &:after {
                                @extend %cell-rounded-background;
                            }
                        }

                        &.is-last-hovered,
                        &.is-last-selected {
                            &:before {
                                left: 0;
                            }
                        }

                        &.is-first-hovered,
                        &.is-first-selected {
                            &:before {
                                left: 50%;
                            }
                        }

                        &.is-selected.is-within-selected {
                            background-color: $purple100;
                        }
                    }

                    a.datepicker-cell[role='button'] {
                        &:focus {
                            outline: none;
                            background-color: unset;
                        }

                        &:hover {
                            background-color: unset;
                            color: $white;

                            :after {
                                @extend %cell-rounded-background;
                                color: $white;
                            }
                        }
                    }
                }
            }
        }

        .datepicker-footer {
            margin: 6px 0 0 0;
            padding: 0;
            border: none;
        }
    }
}
